""" Script for generating figures, see sww2timeseries for documentation"""

from anuga.pyvolution.util import sww2timeseries
import project
from os import sep

# define directory location of sww and gauge data
production_dirs = {'20060426_004129': '1.5 AHD',
                   '20060426_004237': '-1.5 AHD',
                   '20060515_001733': '0 AHD'}

for label_id in production_dirs.keys():
    
    file_loc = project.outputdir + label_id + sep
    swwfile = file_loc + project.basename + '.sww'
    swwfiles[swwfile] = label_id
    
# generate figures - see sww2timeseries for documentation
sww2timeseries(swwfiles,
               project.gauge_filename,
               production_dirs,
               report = False,
               plot_quantity = ['stage', 'speed'],
               time_min = None,
               time_max = None,
               title_on = False,
               verbose = True)

print 'finished plotting time series'





